import * as React from "react";
import { MarginClass, PaddingClass, BgColorClass, FgColorClass, VerticalAlignment, HorizontalAlignment } from "./../../utilities/uiHelpers";
export interface IGrid extends React.HTMLProps<Grid> {
    debugMode?: boolean;
    disableFlexOverride?: boolean;
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
    table?: boolean;
    fillContainer?: boolean;
}
export declare class Grid extends React.Component<IGrid, {}> {
    render(): JSX.Element;
    componentDidMount(): void;
}
export interface IRow extends React.HTMLProps<Row> {
    height?: number | "auto";
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
}
export declare class Row extends React.Component<IRow, any> {
    render(): JSX.Element;
}
export interface ICol extends React.HTMLProps<Col> {
    horizontalAlignment?: HorizontalAlignment;
    verticalAlignment?: VerticalAlignment;
    width?: number | "auto";
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
}
export declare class Col extends React.Component<ICol, {}> {
    render(): JSX.Element;
}
