"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var ReactDOM = require("react-dom");
var _ = require("underscore");
var classNames = require("classnames");
var uiHelpers_1 = require("./../../utilities/uiHelpers");
var Grid = (function (_super) {
    __extends(Grid, _super);
    function Grid() {
        _super.apply(this, arguments);
    }
    Grid.prototype.render = function () {
        var originalClassName = this.props.className;
        var attrs = _.omit(this.props, "className", "debugMode", "table", "fillContainer");
        var classes = classNames(originalClassName, "grid", {
            "fill-container": this.props.fillContainer,
            "grid-debug": this.props.debugMode,
            "table-grid": this.props.table
        });
        if (this.props.fillContainer && !this.props.disableFlexOverride) {
            return (React.createElement("div", {className: "flex-override"}, React.createElement("div", __assign({}, attrs, {className: classes}))));
        }
        else {
            return (React.createElement("div", __assign({}, attrs, {className: classes})));
        }
    };
    Grid.prototype.componentDidMount = function () {
        if (this.props.fillContainer && !this.props.disableFlexOverride) {
            ReactDOM.findDOMNode(this).parentElement.style.position = "relative";
        }
    };
    return Grid;
}(React.Component));
exports.Grid = Grid;
var Row = (function (_super) {
    __extends(Row, _super);
    function Row() {
        _super.apply(this, arguments);
    }
    Row.prototype.render = function () {
        var attrs = _.omit(this.props, "className", "fixed", "centerContent");
        var classes = classNames(this.props.className, "row", this.props.height ? "no-flex" : "");
        var styles = this.props.style;
        var colStyles;
        if (typeof this.props.height === "number") {
            styles = _.extend({ maxHeight: this.props.height + "px", height: "100%" }, styles);
        }
        return React.createElement("div", __assign({}, attrs, {className: classes, style: styles}), React.Children.map(this.props.children, function (c) {
            return c ? React.cloneElement(c, { style: colStyles ? _.extend(colStyles, c.props.style) : c.props.style }) : null;
        }));
    };
    return Row;
}(React.Component));
exports.Row = Row;
var Col = (function (_super) {
    __extends(Col, _super);
    function Col() {
        _super.apply(this, arguments);
    }
    Col.prototype.render = function () {
        var alignmentClasses = uiHelpers_1.LayoutHelpers.GetAlignmentClasses(this.props.verticalAlignment, this.props.horizontalAlignment);
        var classes = classNames("col", this.props.className, alignmentClasses, {
            "no-flex": this.props.width !== undefined,
        });
        var attrs = _.omit(this.props, "className", "fixed", "horizontalAlignment", "verticalAlignment");
        var styles = this.props.style;
        if (typeof this.props.width === "number") {
            styles = _.extend({ maxWidth: this.props.width + "px", width: "100%" }, styles);
        }
        return React.createElement("div", __assign({}, attrs, {className: classes, style: styles}));
    };
    return Col;
}(React.Component));
exports.Col = Col;
